# Choropleth_Chart_Function

Choropleth Chart를 plotly를 통해 그리고 저장하거나 plotly.GraphObject를 리턴하는 함수. 
![Choropleth Chart Example](output/1인가구 중년이상.png "example")
# 구조

`choropleth.py`는 plotly `GraphObject`를 리턴하는 함수이며 Choropleth Chart를 그려주는 함수입니다. 
사용 예제는 `example.py`! 에 있습니다.

choropleth_chart에 shp와 넣고자 하는 데이터는 당연한 이야기이지만 index가 동일해야 합니다. 그러지 않으면 올바르지 않은 그래프가 출력됩니다.
save 파라미터 조정으로 static image 저장여부를 지정할 수 있습니다. 
안타깝게도 plotly는 geojson object를 직접 조정 할 수 있는 방법이 없어 workaround를 사용하였기에 이미지 파일 크기를 직접 지정 할 수는 없습니다.  
자세한것은 예제코드를 보시면 이해가 빠를 것입니다.

choropleth_chart 함수는 voronoi diagram을 활용하여 각 지역마다 들어가는 글자의 위치와 크기를 최적화 하였습니다. 
이러한 voronoi diagram을 활용한 코드는 `algorithm/voronoi.py`에 있습니다. 
이 알고리즘은 다른 곳에도 응용 될 수 있기 때문에 분리하였습니다.




